!c Description:
!c   κ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-02-25    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_matrix_const
  interface

     subroutine matrix_const(temp, mol, mu, phase, struct, B)
       real(8), intent(in)               :: temp       
       real(8), intent(in)               :: mol(:)     
       real(8), intent(in)               :: mu(:)      
       real(8), intent(out), allocatable :: B(:)       
       real(8), intent(in)               :: struct(:,:)
       integer(8), intent(in)            :: phase(:)   
     end subroutine matrix_const

  end interface
end module interface_matrix_const



subroutine matrix_const(temp, mol, mu, phase, struct, B)
  use prm_phys, only: gasr 
  use interface_phase_pack

  implicit none
  real(8), intent(in)               :: temp         !
  real(8), intent(in)               :: mol(:)       !ؼΥ
  real(8), intent(in)               :: mu(:)        !إݥƥ󥷥
  real(8), intent(out), allocatable :: B(:)         !
  real(8), intent(in)               :: struct(:,:)  !ؼ˴ޤޤ븵ǿ
  integer(8), intent(in)            :: phase(:)     !ؼֹ

  integer(8), allocatable :: phase_tmp(:)
  integer(8)              :: pmax         !¸ߤο
  integer(8)              :: smax 
  integer(8)              :: emax         !¸ߤ븵Ǥο
  integer(8)              :: enum
  integer(8)              :: pnum
  integer(8)              :: max
  integer(8)              :: min
  
  
!!!
!!!ѿν
!!!
  smax = size(struct, 1)
  emax = size(struct, 2)

  allocate(phase_tmp(smax))
  phase_tmp = phase
  call phase_pack(phase_tmp)
  pmax = maxval(phase_tmp)

  allocate(B(emax + pmax))
  B = 0.0D0
  
!!!
!!!Ǥη׻
!!!
  do enum = 1, emax
     B(enum) = sum(struct(:,enum) * mol(:) * mu(:))  / (gasr * temp) &
          & + dot_product(struct(:, enum), mol(:))
  end do

!  write(*,*) 299489.6502445514 / 296680.4495236789
!  write(*,*) 0.7204206012401558 / 0.7136630853437544
!  write(*,*) "إݥƥ󥷥", mu
!  write(*,*) "ǿ Be"
!  do enum = 1, emax
!     write(*,*) dot_product(struct(:, enum), mol(:))
!  end do
  
  do pnum = 1, pmax
     min = minloc(phase_tmp, 1, phase_tmp == pnum)
     max = min + count(phase_tmp == pnum) - 1
     
     B(emax + pnum) = sum(mu(min: max) * mol(min: max)) / (gasr * Temp)
  end do
  

end subroutine matrix_const
